// Written by George Ng
// ngg@ecf.utoronto.ca
// Testbench for toplevel hardware module
// WARNING: does not work very well properly, use at own discretion

`timescale  1 ns / 1 ps

module displaypattern_tb ();

   `define  sys_clk_per 37.037
   
   reg sys_clk;
   reg reset;

   // connections to the video DAC
   wire        VGA_OUT_PIXEL_CLOCK_P;
   wire        VGA_COMP_SYNCH_N;
   wire        VGA_OUT_BLANK_N;
   wire        VGA_HSYNCH_N;
   wire        VGA_VSYNCH_N;
   wire [7:0]  VGA_OUT_RED_P;
   wire [7:0]  VGA_OUT_GREEN_P;
   wire [7:0]  VGA_OUT_BLUE_P;

   // connections to the ZBT RAM BANK 2
   wire        MEMORY_CLK_P;
   wire        MEMORY_CLKEN_N;
   wire        MEMORY_WEN_N;
   wire        MEMORY_WENA_N;
   wire        MEMORY_WENB_N;
   wire        MEMORY_WENC_N;
   wire        MEMORY_WEND_N;
   wire        MEMORY_ADV_LD_N;
   wire        MEMORY_OEN_N;
   wire        MEMORY_CEN_N;
   wire [18:0] MEMORY_ADDR_P;
   wire [7:0]  MEMORY_DATA_A_P;
   wire [7:0]  MEMORY_DATA_B_P;
   wire [7:0]  MEMORY_DATA_C_P;
   wire [7:0]  MEMORY_DATA_D_P;

   // connections to the ZBT RAM BANK 0
   wire        MEMORY_0_CLK_P;
   wire        MEMORY_0_CLKEN_N;
   wire        MEMORY_0_WEN_N;
   wire        MEMORY_0_WENA_N;
   wire        MEMORY_0_WENB_N;
   wire        MEMORY_0_WENC_N;
   wire        MEMORY_0_WEND_N;
   wire        MEMORY_0_ADV_LD_N;
   wire        MEMORY_0_OEN_N;
   wire        MEMORY_0_CEN_N;
   wire [18:0] MEMORY_0_ADDR_P;
   wire [7:0]  MEMORY_0_DATA_A_P;
   wire [7:0]  MEMORY_0_DATA_B_P;
   wire [7:0]  MEMORY_0_DATA_C_P;
   wire [7:0]  MEMORY_0_DATA_D_P;
   
   // generate clock
   initial begin
      sys_clk = 0;
      forever #(`sys_clk_per/2) sys_clk = ~sys_clk;
   end   
   
   initial begin
      reset = 1'b1;
      #(`sys_clk_per/2 + 2*`sys_clk_per) //realign signals to +ve clock edge and wait a few clocks
      reset = 1'b0;
   end

   displaypattern udisplaypattern (
      // connections to the video DAC
      .VGA_OUT_PIXEL_CLOCK_P(VGA_OUT_PIXEL_CLOCK_P),
      .VGA_COMP_SYNCH_N(VGA_COMP_SYNCH_N),
      .VGA_OUT_BLANK_N(VGA_OUT_BLANK_N),
      .VGA_HSYNCH_N(VGA_HSYNCH_N),
      .VGA_VSYNCH_N(VGA_VSYNCH_N),
      .VGA_OUT_RED_P(VGA_OUT_RED_P),
      .VGA_OUT_GREEN_P(VGA_OUT_GREEN_P),
      .VGA_OUT_BLUE_P(VGA_OUT_BLUE_P),

      // connections to the ZBT RAM BANK 2
      .MEMORY_CLK_P(MEMORY_CLK_P),
      .MEMORY_CLKEN_N(MEMORY_CLKEN_N),
      .MEMORY_WEN_N(MEMORY_WEN_N),
      .MEMORY_WENA_N(MEMORY_WENA_N),
      .MEMORY_WENB_N(MEMORY_WENB_N),
      .MEMORY_WENC_N(MEMORY_WENC_N),
      .MEMORY_WEND_N(MEMORY_WEND_N),
      .MEMORY_ADV_LD_N(MEMORY_ADV_LD_N),
      .MEMORY_OEN_N(MEMORY_OEN_N),
      .MEMORY_CEN_N(MEMORY_CEN_N),
      .MEMORY_ADDR_P(MEMORY_ADDR_P),
      .MEMORY_DATA_A_P(MEMORY_DATA_A_P),
      .MEMORY_DATA_B_P(MEMORY_DATA_B_P),
      .MEMORY_DATA_C_P(MEMORY_DATA_C_P),
      .MEMORY_DATA_D_P(MEMORY_DATA_D_P),

      // connections to the ZBT RAM BANK 0
      .MEMORY_0_CLK_P(MEMORY_0_CLK_P),
      .MEMORY_0_CLKEN_N(MEMORY_0_CLKEN_N),
      .MEMORY_0_WEN_N(MEMORY_0_WEN_N),
      .MEMORY_0_WENA_N(MEMORY_0_WENA_N),
      .MEMORY_0_WENB_N(MEMORY_0_WENB_N),
      .MEMORY_0_WENC_N(MEMORY_0_WENC_N),
      .MEMORY_0_WEND_N(MEMORY_0_WEND_N),
      .MEMORY_0_ADV_LD_N(MEMORY_0_ADV_LD_N),
      .MEMORY_0_OEN_N(MEMORY_0_OEN_N),
      .MEMORY_0_CEN_N(MEMORY_0_CEN_N),
      .MEMORY_0_ADDR_P(MEMORY_0_ADDR_P),
      .MEMORY_0_DATA_A_P(MEMORY_0_DATA_A_P),
      .MEMORY_0_DATA_B_P(MEMORY_0_DATA_B_P),
      .MEMORY_0_DATA_C_P(MEMORY_0_DATA_C_P),
      .MEMORY_0_DATA_D_P(MEMORY_0_DATA_D_P),

      .pixel_clock(sys_clk), //aka system clock (look in ucf)
      .reset(reset)
      );

   K7N163601A uBANK0 (
      .Dq({MEMORY_0_DATA_D_P, MEMORY_0_DATA_C_P, MEMORY_0_DATA_B_P, MEMORY_0_DATA_A_P}),
      .Addr(MEMORY_0_ADDR_P),
      .K(MEMORY_0_CLK_P),
      .CKEb(MEMORY_0_CLKEN_N),
      .Bwa_n(MEMORY_0_WENA_N),
      .Bwb_n(MEMORY_0_WENB_N),
      .Bwc_n(MEMORY_0_WENC_N),
      .Bwd_n(MEMORY_0_WEND_N),
      .WEb(MEMORY_0_WEN_N),
      .ADV(MEMORY_0_ADV_LD_N),
      .OEb(MEMORY_0_OEN_N),
      .CS1b(MEMORY_0_CEN_N),
      .CS2(1'b1),
      .CS2b(1'b0),
      .LBOb(1'b1),
      .ZZ(1'b0)
   );

   K7N163601A uBANK2 (
      .Dq({MEMORY_DATA_D_P, MEMORY_DATA_C_P, MEMORY_DATA_B_P, MEMORY_DATA_A_P}),
      .Addr(MEMORY_ADDR_P),
      .K(MEMORY_CLK_P),
      .CKEb(MEMORY_CLKEN_N),
      .Bwa_n(MEMORY_WENA_N),
      .Bwb_n(MEMORY_WENB_N),
      .Bwc_n(MEMORY_WENC_N),
      .Bwd_n(MEMORY_WEND_N),
      .WEb(MEMORY_WEN_N),
      .ADV(MEMORY_ADV_LD_N),
      .OEb(MEMORY_OEN_N),
      .CS1b(MEMORY_CEN_N),
      .CS2(1'b1),
      .CS2b(1'b0),
      .LBOb(1'b1),
      .ZZ(1'b0)      
   );
   
endmodule